#include <SPI.h>

const byte selectionPin = 10;
//byte canal = 0;
byte data_R;
byte resultat[8]; // Tableau des valeurs courantes
byte resultatPrec[8] = {0, 0, 0, 0, 0, 0, 0, 0}; // Tableau des valeurs de référence

void setup() {
  Serial.begin(9600); // Initialisation de la communication série
  SPI.begin(); // Initilisation de la communication SPI avec l' ADC088S102
  pinMode(selectionPin, OUTPUT);
}

void loop() {
  digitalWrite(selectionPin, LOW); // Démarrage de la communication SPI
  for (byte canal = 0; canal < 8; canal++){ // PArcoure l'ensemble des canaux du ADC088S102
    data_R = SPI.transfer(((canal+1) << 3)); // Récupère les 4 octets de poids forts du canal courant et envoi l'adresse du prochain canal à lire
    resultat[canal] = (data_R << 4); // Décale les bits voir Figure 1 de la feuille de caractéristiques
    data_R = SPI.transfer(((canal+1) << 3)); // Récupère les 4 bits de poids faibles et envoi l'adresse du prochain canal à lire
    resultat[canal] += (data_R >> 4); // Décale les bits voir Figure 1 de la feuille de caractéristiques
  }
  digitalWrite(selectionPin, HIGH); // Arret de la transmission SPI
  boolean flag = false;
  for (int i = 0; i < 8; i++) {
    if (resultatPrec[i] != resultat[i]) { // Teste s'il y a des changements dans les valeurs
      flag = true;
    }
  }
  if (flag) { // Si changements alors affichage des valeurs
    for (byte canal = 0; canal < 8; canal++) {
      Serial.print(resultat[canal], DEC); // Envoi de la nouvelle valeur par communication série
      Serial.print(" ");
      resultatPrec[canal] = resultat[canal]; // Met à jour les valeurs pour la référence
    }
    Serial.println("");
  }
}
